import { Component, h, Prop, State } from '@stencil/core';
import { randomIdGenerator } from '../../../global/utils/randomIdGenerator';

@Component({
  tag: 'digi-icon-news',
  styleUrl: 'icon-news.scss',
  scoped: true
})
export class IconNews {
  /**
   * Lägger till ett titleelement i svg:n
   * @en Adds a title element inside the svg
   */
  @Prop() afTitle: string;

  /**
   * Lägger till ett descelement i svg:n
   * @en Adds a desc element inside the svg
   */
  @Prop() afDesc: string;

  /**
   * För att dölja ikonen för skärmläsare. Default är satt till true.
   * @en Hides the icon for screen readers. Default is set to true.
   */
  @Prop() afSvgAriaHidden = true;

  /**
   * Referera till andra element på sidan för att definiera ett tillgängligt namn.
   * @en Reference other elements on the page to define an accessible name.
   */
  @Prop() afSvgAriaLabelledby: string;

  @State() titleId: string = randomIdGenerator('icontitle');

  render() {
    return (
      <svg
        class="digi-icon-news"
        width="48"
        height="48"
        viewBox="0 0 48 48"
        aria-hidden={this.afSvgAriaHidden ? 'true' : 'false'}
        aria-labelledby={
          this.afSvgAriaLabelledby
            ? this.afSvgAriaLabelledby
            : this.afTitle
              ? this.titleId
              : undefined
        }
        xmlns="http://www.w3.org/2000/svg">
        {this.afTitle && <title id={this.titleId}>{this.afTitle}</title>}
        {this.afDesc && <desc>{this.afDesc}</desc>}
        <path
          class="digi-icon-news__shape"
          d="M46,8 L7.33333333,8 C6.2305,8 5.33333333,8.91327232 5.33333333,10.0357143 L5.33333333,10.7142857 L2,10.7142857 C0.895416667,10.7142857 0,11.625692 0,12.75 L0,36.5 C0,38.7486161 1.79083333,40.5714286 4,40.5714286 L46,40.5714286 C47.10275,40.5714286 48,39.6581562 48,38.5357143 L48,10.0357143 C48,8.91327232 47.10275,8 46,8 Z M2.66666667,36.5 L2.66666667,13.4285714 L5.33333333,13.4285714 L5.33333333,36.5 C5.33333333,37.2482946 4.73516667,37.8571429 4,37.8571429 C3.26483333,37.8571429 2.66666667,37.2482946 2.66666667,36.5 Z M45.3333333,37.8571429 L7.7715,37.8571429 C7.92297604,37.4212905 8.00025232,36.9623191 8,36.5 L8,10.7142857 L45.3333333,10.7142857 L45.3333333,37.8571429 Z M11.6666667,29.7142857 L25.6666667,29.7142857 C26.2189167,29.7142857 26.6666667,29.2585402 26.6666667,28.6964286 L26.6666667,14.4464286 C26.6666667,13.884317 26.2189167,13.4285714 25.6666667,13.4285714 L11.6666667,13.4285714 C11.1144167,13.4285714 10.6666667,13.884317 10.6666667,14.4464286 L10.6666667,28.6964286 C10.6666667,29.2585402 11.1144167,29.7142857 11.6666667,29.7142857 Z M13.3333333,16.1428571 L24,16.1428571 L24,27 L13.3333333,27 L13.3333333,16.1428571 Z M10.6666667,34.125 L10.6666667,33.4464286 C10.6666667,32.884317 11.1144167,32.4285714 11.6666667,32.4285714 L25.6666667,32.4285714 C26.2189167,32.4285714 26.6666667,32.884317 26.6666667,33.4464286 L26.6666667,34.125 C26.6666667,34.6871116 26.2189167,35.1428571 25.6666667,35.1428571 L11.6666667,35.1428571 C11.1144167,35.1428571 10.6666667,34.6871116 10.6666667,34.125 Z M29.3333333,34.125 L29.3333333,33.4464286 C29.3333333,32.884317 29.7810833,32.4285714 30.3333333,32.4285714 L41.6666667,32.4285714 C42.2189167,32.4285714 42.6666667,32.884317 42.6666667,33.4464286 L42.6666667,34.125 C42.6666667,34.6871116 42.2189167,35.1428571 41.6666667,35.1428571 L30.3333333,35.1428571 C29.7810833,35.1428571 29.3333333,34.6871116 29.3333333,34.125 Z M29.3333333,28.6964286 L29.3333333,28.0178571 C29.3333333,27.4557455 29.7810833,27 30.3333333,27 L41.6666667,27 C42.2189167,27 42.6666667,27.4557455 42.6666667,28.0178571 L42.6666667,28.6964286 C42.6666667,29.2585402 42.2189167,29.7142857 41.6666667,29.7142857 L30.3333333,29.7142857 C29.7810833,29.7142857 29.3333333,29.2585402 29.3333333,28.6964286 Z M29.3333333,17.8392857 L29.3333333,17.1607143 C29.3333333,16.5986027 29.7810833,16.1428571 30.3333333,16.1428571 L41.6666667,16.1428571 C42.2189167,16.1428571 42.6666667,16.5986027 42.6666667,17.1607143 L42.6666667,17.8392857 C42.6666667,18.4013973 42.2189167,18.8571429 41.6666667,18.8571429 L30.3333333,18.8571429 C29.7810833,18.8571429 29.3333333,18.4013973 29.3333333,17.8392857 Z M29.3333333,23.2678571 L29.3333333,22.5892857 C29.3333333,22.0271741 29.7810833,21.5714286 30.3333333,21.5714286 L41.6666667,21.5714286 C42.2189167,21.5714286 42.6666667,22.0271741 42.6666667,22.5892857 L42.6666667,23.2678571 C42.6666667,23.8299687 42.2189167,24.2857143 41.6666667,24.2857143 L30.3333333,24.2857143 C29.7810833,24.2857143 29.3333333,23.8299687 29.3333333,23.2678571 Z"
          fill="currentColor"
          fill-rule="nonzero"
        />
      </svg>
    );
  }
}
